;EasyCodeName=Module1,1
;The MASM32 Runtime Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	\masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	\masm32\fpulib\fpu.inc
IncludeLib   \masm32\fpulib\fpu.lib
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Const
maxDecimalPlace = 15

.Data
Number Real10 ?
modifyNumber Byte 100 Dup(?)

.Code

start:
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	Call Main
	inkey        ; pause the screen while waiting for user to press any key
	             ; to continue
    exit
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<   Input10 procedure will convert input   <<
;<<   from keyboard into real10 numbers      <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

InputR10 Proc pR10:DWord
    LOCAL r8:REAL8
    invoke crt_scanf, SADD("%lf"), ADDR r8
    mov eax, pR10
    finit
    fld r8
    fstp REAL10 PTR [eax]
    ret
InputR10 EndP

Main Proc

Local WantContinue:DWord
Local stringLength:DWord

   Mov WantContinue, 0   ; initialize WantContinue to zero

  .While ((WantContinue >= 0) && (WantContinue < -1))
  ; while WantContinue is greater than or equal to 0 And
  ; WantContinue is less than -1 do
  	print chr$(13, 10)  ; a carriage return line feed will be outputted to the
  	                    ; screen
    print chr$("Enter a real Number : ")
    Invoke InputR10, Addr Number

    print chr$(13, 10, " Outputting the real10 floating point Number :  ")
    print real10$ (Number)
    print chr$(13, 10, " by using real10$ function .", 13, 10, 13, 10)

    Invoke FpuFLtoA, Addr Number, maxDecimalPlace, Addr modifyNumber, SRC1_REAL Or STR_REG
    Or Eax, Eax
    Jz _Error
    print chr$(" Displaying the real10 floating point Number :  ")
    print Addr modifyNumber
    print chr$(13, 10, " by using FpuFLtoA function to ")
    print str$(maxDecimalPlace)
    print chr$(" decimal places maximum.")
    print chr$(13, 10, 13, 10)

    print chr$(" Removing extra zeros with TrailZero Proc :  ")
    Lea Esi, modifyNumber
    call TrailZero
    print Addr modifyNumber

    Jmp _Continue

_Error:
	print chr$(13, 10)
    print chr$(" Error displaying floating point number as string ")
    print chr$("by using FpuFLtoA function!", 13, 10, 13, 10)

_Continue:
    print chr$(13, 10, 13, 10, 13, 10)
    Mov WantContinue, sval(input("Enter -1 to quit program : "))
    Invoke ClearScreen
  .EndW

    print chr$(13, 10)
    Ret
Main EndP
TrailZero Proc
    Invoke StrLen, Esi
    Mov Ecx, Eax
    Dec Ecx
@@:
    Mov Al, Byte Ptr [Esi + Ecx]
    Cmp Al, "0"
    Jnz @F
    Dec Ecx
    Jnz @B
@@:
    Inc Ecx
    Mov Byte Ptr [Esi + Ecx], 0

    Dec Ecx
    .If (Byte Ptr [Esi + Ecx] == ".")
       Mov Byte Ptr [Esi + Ecx], 0
    .EndIf

    ret
TrailZero EndP

End start
